"""
Thomas Wick, Sebastian Kinnewig
Leibniz University Hannover
Institute of Applied Mathematics
Germany

https://www.pec3.org/events/school2022/

Exercise Class 1 - Iterative Solvers and Gradient Decent Methods

Exercise 2 - 
"""


"""
===== PACKAGES =====
"""
# Basic math tools 
import numpy as np

# Library to create plots 
import matplotlib.pyplot as plt 


""" 
===== Fixed section ===
In this section, we create the system matrix A from the Poisson problem, 
which was introduced on the exercise sheet and the right-hand side for 
the Poisson problem f, also as introduced in equation (1) on the exercise 
sheet
"""
# This function is used to create the system matrix A
def laplace_matrix( n, L = 1.0 ):
  # initialize an (n + 2) x (n + 2) matrix with zeros
  A = np.zeros((n + 2, n + 2))

  # compute h
  h = L / ( n + 1)

  # fill in the matrix (remark: we skip the first and the last line of the matrix)
  for i in range( 1, n + 1 ):
    # diagonal
    A[i][i] = 2 / h ** 2
    # fill the off diagonals
    A[i][i - 1] = - 1 / h ** 2
    A[i][i + 1] = - 1 / h ** 2

  # fill in the boundary values
  A[0][0] = 1 / h ** 2
  A[n + 1][n + 1] = 1 / h ** 2

  return A

# This function is used to create the right-hand side
def laplace_rhs( n ):
  # initialze a vector of length n+2 with zero
  f = np.zeros(n + 2)
  
  # fill the vector (remark: we skip the first and the last line of the vector)
  for i in range( 1, n + 1 ):
    f[i] = -1.0

  return f
  
# Create a plot
def create_plot( x ):
  plt.plot(x)
  plt.ylabel('u(x)')
  plt.xlabel('x')
  plt.show()
  

"""
===== Exercise 2 (a): CG Method =====
Implement a CG method, you can either use the pseudo code on the exercise sheet as a starting point 
or the description provided on slide 53

Hint: The matrix vector product between a vector v and a matrix M can be computed with: np.dot(M,v)
      and the vector vector product between a vector v1 and a vector v2 can be computed with: np.dot(v1, v2)
"""

def cg(M, f, epsilon = 1e-5, max_iterations = 1000):
  x_old = np.zeros( size )

  # TODO
  
  return x_old

# We want to solve the following LES:
# A.x = f

n = 8                  # number of discretization points
A = laplace_matrix(n)  # (Given) The system matrix from LES
f = laplace_rhs(n)     # (Given) The right hand side from the LES
x = cg(A, f)           # Compute x with CG
print(x)
create_plot(x)


"""
===== Exercise 2 (b) Comparison Between the CG Method and Iterative Methods =====
Consider different n (for example n = 8, 16, 32) and compare the results between the different methods.
Especially compare the number of iteration steps of both methods.
"""
