"""
Thomas Wick, Sebastian Kinnewig
Leibniz University Hannover
Institute of Applied Mathematics
Germany

https://www.pec3.org/events/school2022/

Exercise Class 1 - Iterative Solvers and Gradient Decent Methods

Exercise 3 - PCG
"""


"""
===== PACKAGES =====
"""
# Basic math tools 
import numpy as np

# Library to create plots 
import matplotlib.pyplot as plt 


"""
===== Exercise 3: (a) SOR Preconditioner =====
Implement the SOR Preconditioner as descibed on slide 63
"""
#TODO


"""
===== Exercise 3: (b) Implement the PCG =====
Implement the PCG method as described on slide 60
"""

#TODO


"""
===== Exercise 3: (c) Comparison =====
Compare different preconditioners

Here we use a random generated matrix for the test case, to ensure that the matrix we 
are considering is symmetric and semi positiv definit we generate first randomly a 
matrix K and than compute A = K.K^T, so A is ensured to be SPD and symmetric.
"""

# create the n x n identity matrix
def identity ( n ):
  result = np.zeros((n,n))

  for i in range(n):
    result[i][i] = 1.0

  return result

# create a test case
n = 100 
K = np.random.randint(10, size=(n, n))
A = np.dot(K, K.T)
f = np.random.randint(10, size=(n))

print("Using the identity matrix as preconditioner:")
pcg(A, f, identity(n) )

print("Using SOR as preconditioner")
# we need P^(-1) but so far we only computed P, as we now just want to test our 
# pcg method, we are using the invert function provided by numpy
pcg(A, f, np.linalg.inv( ssor(A, 0.5) )) 
